import java.util.*;
import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

/*	Send a mail with an attachment */
public class SMail {
public static void main(String args[]) {
	
	MimeBodyPart mb2;
	FileDataSource f;
	String file;
	File f1;

	if(args.length < 6) {
		System.err.println("Usage:" +
		" Smail <to> <from> <smtp> <subj> <msg> <file1 file2...>");
		System.exit(1);
	}

	String to=args[0];
	String from=args[1];
	String smtp=args[2];
	String subj=args[3];
	String msg=args[4];

	for(int i=5;i<args.length;i++) {
		file=args[i];
		f1=new File(file);

		if(!f1.exists()) {
			System.err.println("File "+file+" does not exist!");
			System.exit(1);
		}
	}

	try {

		Properties props=System.getProperties();
		props.put("mail.smtp.host",smtp);
		Session session=Session.getDefaultInstance(props,null);
		MimeMessage ms=new MimeMessage(session);

		ms.setFrom(new InternetAddress(from));
		InternetAddress[] addresses={new InternetAddress(to)};
		ms.setRecipients(Message.RecipientType.TO, addresses);
		ms.setSubject(subj);

		MimeBodyPart mb1=new MimeBodyPart();
		mb1.setText(msg);

		Multipart mp=new MimeMultipart();
		mp.addBodyPart(mb1);

		for(int i=5;i<args.length;i++) {

			mb2=new MimeBodyPart();
			file=args[i];
			f=new FileDataSource(file);

			mb2.setDataHandler(new DataHandler(f));
			mb2.setFileName(f.getName());

			mp.addBodyPart(mb2);
		}

		ms.setContent(mp);
		ms.setSentDate(new Date());
		Transport.send(ms);

	} catch (Exception e) {
		System.err.println("Error: "+e.getMessage());
	}

	System.exit(0);
}
}

