/**
* Special Tokenizer that can be used on strangely separated strings
*/
public class SpecialTokenizer 
	extends Object
{
public static final char SEPARATOR = ',';
public static final char ENCLOSER = '"';
private String line;
private int toparse;
private int pos;
private char sep;
private char enc;

/** Constructor.
* Build a new SpecialTokenizer with the given line and separator. */
public SpecialTokenizer(String line, char separator, char enc)
{
	this.line=line;
	this.sep=separator;
	this.enc=enc;
	toparse=line.length();
	pos=0;
}

/** Constructor.
* Build a new SpecialTokenizer with the given line, the separator is
* the standard " ,". */
public SpecialTokenizer(String line)
{
	this.line=line.trim();
	sep=SEPARATOR;
	enc=ENCLOSER;
	toparse=line.length();
	pos=0;
}

/**
* Return true if there are more token to read */
public boolean hasMoreTokens()
{
	return((toparse-pos)>0);
}

/** recover and return the next token or null if there are no more
* token to read */
public String nextToken()
{
	char ch=' ';
	StringBuffer tok=new StringBuffer("");
	boolean intoken=false;

	/* multiple separator are removed */
	while(true) {
		ch=line.charAt(pos);
		if(ch==sep)
			pos++;
		else
			break;
	}

	for(;pos<toparse;pos++) {

		ch=line.charAt(pos);

		if(ch==enc) {
			intoken=!intoken;
			ch=' ';
		}

		if(intoken)
			tok.append(ch);

		if(ch==sep && ! intoken) {
			pos++;
			break;
		}
	}

	return tok.toString().trim();
}

public void setString(String s)
{
	this.line=s.trim();
	toparse=line.length();
	pos=0;
}
}
